<%@ Page Language="C#" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>JavaScriptConverterDemo</title>
    <style type="text/css">
		body { font-family : Verdana; font-size : 13px; }
		h1 { font-size : 15px }
    </style>
    <script language="javascript">
		function getBoyWithGirlfriend()
		{
			Sys.Net.ServiceMethod.invoke(
				"BoyAndGirl.asmx",
				"GetBoyWithGirlfriend",
				null,
				{
					boyName : $("txtGetBoyName").value,
					girlName : $("txtGetGirlName").value
				},
				onComplete);
			
			function onComplete(boy)
			{
				var result;
				if (boy && boy.Girlfriend &&
					boy.Girlfriend.Boyfriend == boy)
				{
					result = "You did a good job! <br />";
					result += "The boy is " + boy.Name + ", ";
					result += "and his girlfriend is " + boy.Girlfriend.Name + '.';
				}
				else
				{
					result = "There must be something wrong with your converter.";
				}
				
				$("GetBoyWithGirlfriend").innerHTML = result;
			}
		}
		
		function setBoyWithGirlfriend()
		{
			var boyObj = new Object();
			boyObj.Name = $("txtSetBoyName").value;
			boyObj.serialize = Function.createDelegate(boyObj, serialize);
			
			boyObj.Girlfriend = new Object();
			boyObj.Girlfriend.Name = $("txtSetGirlName").value;
			boyObj.Girlfriend.Boyfriend = boyObj;
			
			Sys.Net.ServiceMethod.invoke(
				"BoyAndGirl.asmx",
				"SetBoyWithGirlfriend",
				null,
				{boy : boyObj},
				onComplete);
				
			function onComplete(result)
			{
				if (result)
				{
					$("SetBoyWithGirlfriend").innerHTML = result;
				}
				else
				{
					$("SetBoyWithGirlfriend").innerHTML = 
						"There must be something wrong with your converter."
				}
			}
		}
		
		function serialize()
		{
			var serialize = this.serialize;
			delete this.serialize;
			if (this.Girlfriend && this.Girlfriend.Boyfriend == this)
			{
				this.Girlfriend.__HasClientBoyfriend = true;
				delete this.Girlfriend.Boyfriend;
			}
			
			var result = Sys.Serialization.JSON.serialize(this);
			
			this.serialize = serialize;
			if (this.Girlfriend.__HasClientBoyfriend)
			{
				this.Girlfriend.Boyfriend = this;
				delete this.Girlfriend.__HasClientBoyfriend;
			}
			
			return result;
		}
    </script>
</head>
<body>
    <form id="form1" runat="server">
		<atlas:ScriptManager runat="server" ID="ScriptManger1" />
		
		<h1>Get Boy with Girlfriend</h1>
		<div>Boy's Name: <input type="text" id="txtGetBoyName" /></div>
		<div>Girl's Name: <input type="text" id="txtGetGirlName" /></div>
		<input type="button" onclick="getBoyWithGirlfriend()" value="Get!" />
		<div id="GetBoyWithGirlfriend"></div>
		
		<hr />
		
		<h1>Set Boy with Girlfriend</h1>
		<div>Boy's Name: <input type="text" id="txtSetBoyName" /></div>
		<div>Girl's Name: <input type="text" id="txtSetGirlName" /></div>
		<input type="button" onclick="setBoyWithGirlfriend()" value="Set!" />
		<div id="SetBoyWithGirlfriend"></div>
    </form>
</body>
</html>
